# typed: true

# DO NOT EDIT MANUALLY
# This is an autogenerated file for types exported from the `rubocop-factory_bot` gem.
# Please instead update this file by running `bin/tapioca gem rubocop-factory_bot`.

# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#3
module RuboCop; end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/mixin/configurable_explicit_only.rb#4
module RuboCop::Cop; end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/mixin/configurable_explicit_only.rb#5
module RuboCop::Cop::FactoryBot; end

# Use a consistent style to define associations.
#
# @example EnforcedStyle: implicit (default)
#   # bad
#   factory :post do
#   association :user
#   end
#
#   # good
#   factory :post do
#   user
#   end
#
#   # bad
#   factory :post do
#   association :user, :author
#   end
#
#   # good
#   factory :post do
#   user factory: %i[user author]
#   end
# @example EnforcedStyle: explicit
#   # bad
#   factory :post do
#   user
#   end
#
#   # good
#   factory :post do
#   association :user
#   end
#
#   # bad
#   factory :post do
#   user factory: %i[user author]
#   end
#
#   # good
#   factory :post do
#   association :user, :author
#   end
#
#   # good (NonImplicitAssociationMethodNames: ['email'])
#   sequence :email do |n|
#   "person#{n}@example.com"
#   end
#
#   factory :user do
#   email
#   end
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#63
class RuboCop::Cop::FactoryBot::AssociationStyle < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::ConfigurableEnforcedStyle
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#139
  def association_names(param0); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#96
  def explicit_association?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#113
  def factory_option_matcher(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#108
  def implicit_association?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#82
  def on_send(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#144
  def trait_name(param0); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#134
  def trait_names_from_explicit(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#101
  def with_strategy_build_option?(param0 = T.unsafe(nil)); end

  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#148
  def autocorrect(corrector, node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#156
  def autocorrect_to_explicit_style(corrector, node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#164
  def autocorrect_to_implicit_style(corrector, node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#174
  def bad?(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#195
  def bad_associations_in(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#201
  def children_of_factory_block(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#213
  def factory_names_from_explicit(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#185
  def keyword?(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#223
  def non_implicit_association_method_name?(method_name); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#227
  def non_implicit_association_method_names; end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#240
  def options_for_autocorrect_to_implicit_style(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#232
  def options_from_explicit(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#249
  def trait_within_trait?(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#68
RuboCop::Cop::FactoryBot::AssociationStyle::DEFAULT_NON_IMPLICIT_ASSOCIATION_METHOD_NAMES = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#76
RuboCop::Cop::FactoryBot::AssociationStyle::KEYWORDS = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/association_style.rb#75
RuboCop::Cop::FactoryBot::AssociationStyle::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# Always declare attribute values as blocks.
#
# @example
#   # bad
#   kind [:active, :rejected].sample
#
#   # good
#   kind { [:active, :rejected].sample }
#
#   # bad
#   closed_at 1.day.from_now
#
#   # good
#   closed_at { 1.day.from_now }
#
#   # bad
#   count 1
#
#   # good
#   count { 1 }
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#27
class RuboCop::Cop::FactoryBot::AttributeDefinedStatically < ::RuboCop::Cop::Base
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#85
  def association?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#38
  def factory_attributes(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#42
  def on_block(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#33
  def value_matcher(param0 = T.unsafe(nil)); end

  private

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#119
  def attribute_defining_method?(method_name); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#58
  def autocorrect(corrector, node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#87
  def autocorrect_replacing_parens(corrector, node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#94
  def autocorrect_without_parens(corrector, node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#103
  def braces(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#66
  def offensive_receiver?(receiver, node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#80
  def proc?(attribute); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#72
  def receiver_matches_first_block_argument?(receiver, node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#115
  def reserved_method?(method_name); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#111
  def value_hash_without_braces?(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/attribute_defined_statically.rb#30
RuboCop::Cop::FactoryBot::AttributeDefinedStatically::MSG = T.let(T.unsafe(nil), String)

# Handles `ExplicitOnly` configuration parameters.
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/mixin/configurable_explicit_only.rb#7
module RuboCop::Cop::FactoryBot::ConfigurableExplicitOnly
  include ::RuboCop::FactoryBot::Language

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/mixin/configurable_explicit_only.rb#16
  def explicit_only?; end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/mixin/configurable_explicit_only.rb#10
  def factory_call?(node); end
end

# Use a consistent style for parentheses in factory_bot calls.
#
# @example `EnforcedStyle: require_parentheses` (default)
#
#   # bad
#   create :user
#   build :login
#
#   # good
#   create(:user)
#   build(:login)
# @example `EnforcedStyle: omit_parentheses`
#
#   # bad
#   create(:user)
#   build(:login)
#
#   # good
#   create :user
#   build :login
#
#   # also good
#   # when method name and first argument are not on same line
#   create(
#   :user
#   )
#   build(
#   :user,
#   name: 'foo'
#   )
# @example `ExplicitOnly: false` (default)
#
#   # bad - with `EnforcedStyle: require_parentheses`
#   FactoryBot.create :user
#   build :user
#
#   # good - with `EnforcedStyle: require_parentheses`
#   FactoryBot.create(:user)
#   build(:user)
# @example `ExplicitOnly: true`
#
#   # bad - with `EnforcedStyle: require_parentheses`
#   FactoryBot.create :user
#   FactoryBot.build :user
#
#   # good - with `EnforcedStyle: require_parentheses`
#   FactoryBot.create(:user)
#   FactoryBot.build(:user)
#   create :user
#   build :user
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#60
class RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::ConfigurableEnforcedStyle
  include ::RuboCop::FactoryBot::Language
  include ::RuboCop::Cop::FactoryBot::ConfigurableExplicitOnly
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#71
  def factory_call(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#79
  def omit_hash_value?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#93
  def on_send(node); end

  private

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#130
  def ambiguous_without_parentheses?(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#101
  def register_offense(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#108
  def register_offense_with_parentheses(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#119
  def register_offense_without_parentheses(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#134
  def remove_parentheses(corrector, node); end

  class << self
    # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#89
    def autocorrect_incompatible_with; end
  end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#128
RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle::AMBIGUOUS_TYPES = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#67
RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle::FACTORY_CALLS = T.let(T.unsafe(nil), Set)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#66
RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle::MSG_OMIT_PARENS = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#65
RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle::MSG_REQUIRE_PARENS = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/consistent_parentheses_style.rb#68
RuboCop::Cop::FactoryBot::ConsistentParenthesesStyle::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Set)

# Checks for create_list usage.
#
# This cop can be configured using the `EnforcedStyle` option
#
# @example `EnforcedStyle: create_list` (default)
#   # bad
#   3.times { create :user }
#   3.times.map { create :user }
#   [create(:user), create(:user), create(:user)]
#   Array.new(3) { create :user }
#
#   # good
#   create_list :user, 3
#
#   # bad
#   3.times { create :user, age: 18 }
#
#   # good - index is used to alter the created models attributes
#   3.times { |n| create :user, age: n }
#
#   # good - contains a method call, may return different values
#   3.times { create :user, age: rand }
# @example `EnforcedStyle: n_times`
#   # bad
#   create_list :user, 3
#   [create(:user), create(:user), create(:user)]
#
#   # good
#   3.times.map { create :user }
# @example `ExplicitOnly: false` (default)
#
#   # bad - with `EnforcedStyle: create_list`
#   3.times { FactoryBot.create :user }
#   3.times { create :user }
#
#   # good - with `EnforcedStyle: create_list`
#   FactoryBot.create_list :user, 3
#   create_list :user, 3
# @example `ExplicitOnly: true`
#
#   # bad - with `EnforcedStyle: create_list`
#   3.times { FactoryBot.create :user }
#
#   # good - with `EnforcedStyle: create_list`
#   FactoryBot.create_list :user, 3
#   create_list :user, 3
#   3.times { create :user }
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#61
class RuboCop::Cop::FactoryBot::CreateList < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::ConfigurableEnforcedStyle
  include ::RuboCop::FactoryBot::Language
  include ::RuboCop::Cop::FactoryBot::ConfigurableExplicitOnly
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#92
  def arguments_include_method_call?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#83
  def block_with_arg_and_used?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#97
  def factory_call(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#107
  def factory_calls_in_array?(param0); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#102
  def factory_list_call(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#111
  def on_array(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#123
  def on_block(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#136
  def on_send(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#72
  def repeat_count(param0 = T.unsafe(nil)); end

  private

  # For ease of modification, it is replaced with the `n_times` style,
  # but if it is not appropriate for the configured style,
  # it will be replaced in the subsequent autocorrection.
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#160
  def autocorrect_same_factory_calls_in_array(corrector, node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#171
  def contains_only_factory?(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#179
  def preferred_message_for_array(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#151
  def repeat_multiple_time?(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#188
  def same_factory_calls_in_array?(node); end
end

# :nodoc
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#194
module RuboCop::Cop::FactoryBot::CreateList::Corrector
  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#197
  def build_options_string(options); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#201
  def format_method_call(node, method, arguments); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#209
  def format_receiver(receiver); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#254
class RuboCop::Cop::FactoryBot::CreateList::CreateListCorrector
  include ::RuboCop::Cop::FactoryBot::CreateList::Corrector

  # @return [CreateListCorrector] a new instance of CreateListCorrector
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#257
  def initialize(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#261
  def call(corrector); end

  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#284
  def build_arguments(node, count); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#293
  def call_replacement(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#275
  def call_with_block_replacement(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#306
  def count_from(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#319
  def format_block(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#327
  def format_multiline_block(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#335
  def format_singleline_block(node); end

  # Returns the value of attribute node.
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#273
  def node; end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#67
RuboCop::Cop::FactoryBot::CreateList::MSG_CREATE_LIST = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#68
RuboCop::Cop::FactoryBot::CreateList::MSG_N_TIMES = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#69
RuboCop::Cop::FactoryBot::CreateList::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# :nodoc
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#217
class RuboCop::Cop::FactoryBot::CreateList::TimesCorrector
  include ::RuboCop::Cop::FactoryBot::CreateList::Corrector

  # @return [TimesCorrector] a new instance of TimesCorrector
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#220
  def initialize(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#224
  def call(corrector); end

  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#246
  def factory_call_block_source; end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#233
  def generate_n_times_block(node); end

  # Returns the value of attribute node.
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/create_list.rb#231
  def node; end
end

# Check for excessive model creation in a list.
#
# @example MaxAmount: 10 (default)
#   # We do not allow more than 10 items to be created
#
#   # bad
#   create_list(:merge_request, 1000, state: :opened)
#
#   # good
#   create_list(:merge_request, 10, state: :opened)
# @example MaxAmount: 20
#   # We do not allow more than 20 items to be created
#
#   # bad
#   create_list(:merge_request, 1000, state: :opened)
#
#   # good
#   create_list(:merge_request, 15, state: :opened)
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/excessive_create_list.rb#26
class RuboCop::Cop::FactoryBot::ExcessiveCreateList < ::RuboCop::Cop::Base
  include ::RuboCop::FactoryBot::Language
  include ::RuboCop::Cop::FactoryBot::ConfigurableExplicitOnly

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/excessive_create_list.rb#33
  def create_list?(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/excessive_create_list.rb#39
  def on_send(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/excessive_create_list.rb#29
RuboCop::Cop::FactoryBot::ExcessiveCreateList::MESSAGE = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/excessive_create_list.rb#37
RuboCop::Cop::FactoryBot::ExcessiveCreateList::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# Use definition in factory association instead of hard coding a strategy.
#
# @example
#   # bad - only works for one strategy
#   factory :foo do
#   profile { create(:profile) }
#   end
#
#   # good - implicit
#   factory :foo do
#   profile
#   end
#
#   # good - explicit
#   factory :foo do
#   association :profile
#   end
#
#   # good - inline
#   factory :foo do
#   profile { association :profile }
#   end
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#29
class RuboCop::Cop::FactoryBot::FactoryAssociationWithStrategy < ::RuboCop::Cop::Base
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#36
  def factory_declaration(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#43
  def factory_strategy_association(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#51
  def on_block(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#33
RuboCop::Cop::FactoryBot::FactoryAssociationWithStrategy::HARDCODED = T.let(T.unsafe(nil), Set)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_association_with_strategy.rb#30
RuboCop::Cop::FactoryBot::FactoryAssociationWithStrategy::MSG = T.let(T.unsafe(nil), String)

# Use string value when setting the class attribute explicitly.
#
# This cop would promote faster tests by lazy-loading of
# application files. Also, this could help you suppress potential bugs
# in combination with external libraries by avoiding a preload of
# application files from the factory files.
#
# @example
#   # bad
#   factory :foo, class: Foo do
#   end
#
#   # good
#   factory :foo, class: 'Foo' do
#   end
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#22
class RuboCop::Cop::FactoryBot::FactoryClassName < ::RuboCop::Cop::Base
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#31
  def class_name(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#35
  def on_send(node); end

  private

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#48
  def allowed?(const_name); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#27
RuboCop::Cop::FactoryBot::FactoryClassName::ALLOWED_CONSTANTS = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#25
RuboCop::Cop::FactoryBot::FactoryClassName::MSG = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_class_name.rb#28
RuboCop::Cop::FactoryBot::FactoryClassName::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# Checks for name style for argument of FactoryBot::Syntax::Methods.
#
# @example EnforcedStyle: symbol (default)
#   # bad
#   create('user')
#   build "user", username: "NAME"
#
#   # good
#   create(:user)
#   build :user, username: "NAME"
#
#   # good - namespaced models
#   create('users/internal')
# @example EnforcedStyle: string
#   # bad
#   create(:user)
#   build :user, username: "NAME"
#
#   # good
#   create('user')
#   build "user", username: "NAME"
# @example `ExplicitOnly: false` (default)
#
#   # bad - with `EnforcedStyle: symbol`
#   FactoryBot.create('user')
#   create('user')
#
#   # good - with `EnforcedStyle: symbol`
#   FactoryBot.create(:user)
#   create(:user)
# @example `ExplicitOnly: true`
#
#   # bad - with `EnforcedStyle: symbol`
#   FactoryBot.create(:user)
#   FactoryBot.build "user", username: "NAME"
#
#   # good - with `EnforcedStyle: symbol`
#   FactoryBot.create('user')
#   FactoryBot.build "user", username: "NAME"
#   FactoryBot.create(:user)
#   create(:user)
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#51
class RuboCop::Cop::FactoryBot::FactoryNameStyle < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::ConfigurableEnforcedStyle
  include ::RuboCop::FactoryBot::Language
  include ::RuboCop::Cop::FactoryBot::ConfigurableExplicitOnly
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#62
  def factory_call(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#69
  def on_send(node); end

  private

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#89
  def namespaced?(name); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#85
  def offense_for_string_style?(name); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#81
  def offense_for_symbol_style?(name); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#93
  def register_offense(name, prefer); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#58
RuboCop::Cop::FactoryBot::FactoryNameStyle::FACTORY_CALLS = T.let(T.unsafe(nil), Set)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#57
RuboCop::Cop::FactoryBot::FactoryNameStyle::MSG = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/factory_name_style.rb#59
RuboCop::Cop::FactoryBot::FactoryNameStyle::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Set)

# Do not create a FactoryBot sequence for an id column.
#
# @example
#   # bad - can lead to conflicts between FactoryBot and DB sequences
#   factory :foo do
#   sequence :id
#   end
#
#   # good - a non-id column
#   factory :foo do
#   sequence :some_non_id_column
#   end
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/id_sequence.rb#19
class RuboCop::Cop::FactoryBot::IdSequence < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::RangeHelp
  include ::RuboCop::FactoryBot::Language
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/id_sequence.rb#27
  def on_send(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/id_sequence.rb#24
RuboCop::Cop::FactoryBot::IdSequence::MSG = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/id_sequence.rb#25
RuboCop::Cop::FactoryBot::IdSequence::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# Checks for redundant `factory` option.
#
# @example
#   # bad
#   association :user, factory: :user
#
#   # good
#   association :user
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#14
class RuboCop::Cop::FactoryBot::RedundantFactoryOption < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::RangeHelp
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#24
  def association_with_a_factory_option(param0 = T.unsafe(nil)); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#42
  def on_send(node); end

  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#55
  def autocorrect(corrector, node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#19
RuboCop::Cop::FactoryBot::RedundantFactoryOption::MSG = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/redundant_factory_option.rb#21
RuboCop::Cop::FactoryBot::RedundantFactoryOption::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Array)

# Use shorthands from `FactoryBot::Syntax::Methods` in your specs.
#
# @example
#   # bad
#   FactoryBot.create(:bar)
#   FactoryBot.build(:bar)
#   FactoryBot.attributes_for(:bar)
#
#   # good
#   create(:bar)
#   build(:bar)
#   attributes_for(:bar)
#
# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#48
class RuboCop::Cop::FactoryBot::SyntaxMethods < ::RuboCop::Cop::Base
  include ::RuboCop::Cop::RangeHelp
  include ::RuboCop::FactoryBot::Language
  extend ::RuboCop::Cop::AutoCorrector

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#73
  def on_send(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#58
  def spec_group?(param0 = T.unsafe(nil)); end

  private

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#87
  def crime_scene(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#109
  def example_group_root?(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#113
  def example_group_root_with_siblings?(node); end

  # @return [Boolean]
  #
  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#101
  def inside_example_group?(node); end

  # source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#94
  def offense(node); end
end

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#53
RuboCop::Cop::FactoryBot::SyntaxMethods::MSG = T.let(T.unsafe(nil), String)

# source://rubocop-factory_bot//lib/rubocop/cop/factory_bot/syntax_methods.rb#55
RuboCop::Cop::FactoryBot::SyntaxMethods::RESTRICT_ON_SEND = T.let(T.unsafe(nil), Set)

# RuboCop factory_bot project namespace
#
# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#5
module RuboCop::FactoryBot
  class << self
    # source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#54
    def attribute_defining_methods; end

    # source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#58
    def reserved_methods; end
  end
end

# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#6
RuboCop::FactoryBot::ATTRIBUTE_DEFINING_METHODS = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#29
RuboCop::FactoryBot::DEFINITION_PROXY_METHODS = T.let(T.unsafe(nil), Array)

# Contains node matchers for common factory_bot DSL.
#
# source://rubocop-factory_bot//lib/rubocop/factory_bot/language.rb#6
module RuboCop::FactoryBot::Language
  extend ::RuboCop::AST::NodePattern::Macros

  # source://rubocop-factory_bot//lib/rubocop/factory_bot/language.rb#30
  def factory_bot?(param0 = T.unsafe(nil)); end
end

# source://rubocop-factory_bot//lib/rubocop/factory_bot/language.rb#9
RuboCop::FactoryBot::Language::METHODS = T.let(T.unsafe(nil), Set)

# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#42
RuboCop::FactoryBot::RESERVED_METHODS = T.let(T.unsafe(nil), Array)

# source://rubocop-factory_bot//lib/rubocop/factory_bot/factory_bot.rb#14
RuboCop::FactoryBot::UNPROXIED_METHODS = T.let(T.unsafe(nil), Array)
